#---------------------------------------------------------------------
#
# Windows SDK DɒXNvg
#
# usage: C:\WorkSpace>perl win32sdk2d.pl windows.h > windows.d
#
#-------------------------------------------------------------------

$sdk_path = "C:\\Program Files\\Microsoft SDK\\Include\\";
$dx_path = "C:\\Program Files\\DirectX\\include\\";

%define = (
#	"UNICODE"          => 1,
	"WINVER"           => 0x501,
	"_WIN32"           => 0x501,
	"_WIN32_WINNT"     => 0x501,
	"_WIN32_IE"        => 0x600,
	"_MSC_VER"         => 1310,
#	"DIRECT3D_VERSION" => 0x0800,
	"__cplusplus"      => 1,
	"_M_IX86"          => 1,
	"_X86_"            => 1,
#	"__midl"           => 1,
	"STRICT"           => 1,
	"NOP_FUNCTION"     => 1,
	"CCHDEVICENAME"    => 1,
	"NOCRYPT"          => 1,
	"NOMCX"            => 1,
	"NOSERVICE"        => 1,
	"__RPCNDR_H_VERSION__" => 475);

%include = (
	"excpt"    => "",
	"stdarg"   => "",
	"stdlib"   => "",
	"string"   => "",
	"ctype"    => "",
	"basetsd"  => "",
	"lzexpand" => "",
	"nb30"     => "",
	"rpc"      => "",
	"rpcndr"   => "",
	"tvout"    => "",
	"winnetwk" => "",
	"winperf"  => "",
	"cderr"    => "",
	"prsht"    => "",
	"stralign" => "",
	"reason"   => "*",
	"pshpack1" => "align(1):",
	"pshpack2" => "align(2):",
	"pshpack4" => "align(4):",
	"pshpack8" => "align(8):",
	"poppack"  => "align:",
	"limits"   => "",
	"d3d8"      => "import win32.directx.d3d8",
	"d3dx8math" => "import win32.directx.d3dx8math",
	"d3dx8core" => "import win32.directx.d3dx8core",
	"d3dx8tex" => "import win32.directx.d3dx8tex",
	"d3dx8mesh" => "import win32.directx.d3dx8mesh",
	"d3dx8shape" => "import win32.directx.d3dx8shape",
	"d3dx8effect" => "import win32.directx.d3dx8effect");

%define_replace = (
	"ANONYMOUS_LOGON_LUID"                 => "const LUID ANONYMOUS_LOGON_LUID = {LowPart: 0x3e6, HighPart: 0x0};",
	"APIENTRY"                             => "",
	"APIPRIVATE"                           => "",
	"BEGIN_INTERFACE"                      => "",
	"BTYPE"                                => "BYTE BTYPE(BYTE x){ return x & N_BTMASK; }",
	"CALLBACK"                             => "",
	"CALLTYPE"                             => "",
	"CBEN_FIRST"                           => "",
	"CBEN_GETDISPINFOA"                    => "",
	"CBEN_GETDISPINFOW"                    => "",
	"CBR_BLOCK"                            => "const HDDEDATA CBR_BLOCK = cast(HDDEDATA)-1;",
	"CCSIZEOF_STRUCT"                      => "",
	"CDECL"                                => "",
	"CDSIZEOF_STRUCT"                      => "",
	"CFSEPCHAR"                            => "const char CFSEPCHAR = '+';",
	"CMYK"                                 => "DWORD CMYK(BYTE c, BYTE m, BYTE y, BYTE k){ return (cast(COLORREF)(((cast(BYTE)(k)|(cast(WORD)(cast(BYTE)(y))<<8))|((cast(DWORD)cast(BYTE)(m))<<16))|((cast(DWORD)cast(BYTE)(c))<<24))); }",
	"CONST"                                => "",
	"CONTAINING_RECORD"                    => "",
	"C_ASSERT"                             => "",
	"CommDlg_OpenSave_GetFilePath"         => "",
	"CommDlg_OpenSave_GetFilePathA"        => "",
	"CommDlg_OpenSave_GetFilePathW"        => "",
	"CommDlg_OpenSave_GetFolderIDList"     => "",
	"CommDlg_OpenSave_GetFolderPath"       => "",
	"CommDlg_OpenSave_GetFolderPathA"      => "",
	"CommDlg_OpenSave_GetFolderPathW"      => "",
	"CommDlg_OpenSave_GetSpec"             => "",
	"CommDlg_OpenSave_GetSpecA"            => "",
	"CommDlg_OpenSave_GetSpecW"            => "",
	"CommDlg_OpenSave_HideControl"         => "",
	"CommDlg_OpenSave_SetControlText"      => "",
	"CommDlg_OpenSave_SetDefExt"           => "",
	"CopyCursor"                           => "alias CopyIcon CopyCursor;",
	"CreateDialogA"                        => "HWND CreateDialogA(HINSTANCE hInstance, LPCSTR lpName, HWND hWndParent, DLGPROC lpDialogFunc){ return CreateDialogParamA(hInstance, lpName, hWndParent, lpDialogFunc, 0L); }",
	"CreateDialogIndirectA"                => "HWND CreateDialogIndirectA(HINSTANCE hInstance, LPCDLGTEMPLATE lpTemplate, HWND hWndParent, DLGPROC lpDialogFunc){ return CreateDialogIndirectParamA(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L); }",
	"CreateDialogIndirectW"                => "HWND CreateDialogIndirectW(HINSTANCE hInstance, LPCDLGTEMPLATE lpTemplate, HWND hWndParent, DLGPROC lpDialogFunc){ return CreateDialogIndirectParamW(hInstance, lpTemplate, hWndParent, lpDialogFunc, 0L); }",
	"CreateDialogW"                        => "HWND CreateDialogW(HINSTANCE hInstance, LPCWSTR lpName, HWND hWndParent, DLGPROC lpDialogFunc){ return CreateDialogParamW(hInstance, lpName, hWndParent, lpDialogFunc, 0L); }",
	"CreateWindowA"                        => "HWND CreateWindowA(LPCSTR lpClassName, LPCSTR lpWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam){ return CreateWindowExA(0L, lpClassName, lpWindowName, dwStyle, x, y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam); }",
	"CreateWindowW"                        => "HWND CreateWindowW(LPCWSTR lpClassName, LPCWSTR lpWindowName, DWORD dwStyle, int x, int y, int nWidth, int nHeight, HWND hWndParent, HMENU hMenu, HINSTANCE hInstance, LPVOID lpParam){ return CreateWindowExW(0L, lpClassName, lpWindowName, dwStyle, x, y, nWidth, nHeight, hWndParent, hMenu, hInstance, lpParam); }",
	"CW_USEDEFAULT"                        => "enum { CW_USEDEFAULT = int.min }",
	"DBG_UNREFERENCED_LOCAL_VARIABLE"      => "",
	"DBG_UNREFERENCED_PARAMETER"           => "",
	"DECLARE_HANDLE"                       => "",
	"DECLARE_INTERFACE"                    => "",
	"DECLARE_INTERFACE_"                   => "",
	"DECLSPEC_ALIGN"                       => "",
	"DECLSPEC_CACHEALIGN"                  => "",
	"DECLSPEC_DEPRECATED"                  => "",
	"DECLSPEC_IMPORT"                      => "",
	"DECLSPEC_NORETURN"                    => "",
	"DECLSPEC_NOVTABLE"                    => "",
	"DECLSPEC_SELECTANY"                   => "",
	"DECLSPEC_UUID"                        => "",
	"DECREF"                               => "uint DECREF(uint x){ return ((x >>> N_TSHIFT) & ~N_BTMASK)|(x & N_BTMASK); }",
	"DEFAULT_UNREACHABLE"                  => "",
	"DIBINDEX"                             => "",
	"DMPAPER_FIRST"                        => "enum { DMPAPER_FIRST = 1 }",
	"DMBIN_FIRST"                          => "enum { DMBIN_FIRST = 1 }",
	"DWLP_DLGPROC"                         => "enum : uint { DWLP_DLGPROC = DWLP_MSGRESULT + LRESULT.sizeof }",
	"DWLP_USER"                            => "enum : uint { DWLP_USER = DWLP_DLGPROC + DLGPROC.sizeof }",
	"DefHookProc"                          => "",
	"DefineHandleTable"                    => "",
	"DialogBox"                            => "",
	"DialogBoxA"                           => "",
	"DialogBoxIndirect"                    => "",
	"DialogBoxIndirectA"                   => "",
	"DialogBoxIndirectW"                   => "",
	"DialogBoxW"                           => "",
	"END_INTERFACE"                        => "",
	"EIRESID"                              => "",
	"EXPENTRY"                             => "",
	"EXTERN_C"                             => "",
	"EXT_IMM64"                            => "", 
	"EnumTaskWindows"                      => "",
	"ExitWindows"                          => "BOOL ExitWindows(DWORD dwReserved, UINT Code){ return ExitWindowsEx(EWX_LOGOFF, 0xFFFFFFFF); }",
	"FAILED"                               => "bit FAILED(HRESULT Status){ return Status < 0; }",
	"FAR"                                  => "",
	"FARSTRUCT"                            => "",
	"FD_CLR"                               => "",
	"FD_ISSET"                             => "",
	"FD_SET"                               => "void FD_SET(int fd, fd_set* set){ if(set.fd_count < FD_SETSIZE){ set.fd_array[set.fd_count++] = fd; }}",
	"FD_ZERO"                              => "void FD_ZERO(fd_set* set){ set.fd_count = 0; }",
	"FIELD_OFFSET"                         => "",
	"FIOASYNC"                             => "",
	"FIONBIO"                              => "",
	"FIONREAD"                             => "",
	"FIRST_IPADDRESS"                      => "",
	"FOURTH_IPADDRESS"                     => "",
	"FORCEINLINE"                          => "",
	"FORWARD_WM_NOTIFY"                    => "",
	"FOURCC_DOS"                           => "",
	"FOURCC_LIST"                          => "",
	"FOURCC_MEM"                           => "",
	"FOURCC_RIFF"                          => "",
	"FreeModule"                           => "alias FreeLibrary FreeModule;",
	"FreeProcInstance"                     => "",
	"GET_APPCOMMAND_LPARAM"                => "",
	"GET_DEVICE_LPARAM"                    => "",
	"GET_FLAGS_LPARAM"                     => "",
	"GET_KEYSTATE_LPARAM"                  => "",
	"GET_KEYSTATE_WPARAM"                  => "",
	"GET_MOUSEORKEY_LPARAM"                => "",
	"GET_NCHITTEST_WPARAM"                 => "",
	"GET_RAWINPUT_CODE_WPARAM"             => "",
	"GET_WHEEL_DELTA_WPARAM"               => "",
	"GET_XBUTTON_WPARAM"                   => "",
	"GetBValue"                            => "BYTE GetBValue(COLORREF rgb){ return cast(BYTE)(rgb >>> 16); }",
	"GetCValue"                            => "BYTE GetCValue(DWORD cmyk){ return cast(BYTE)(cmyk >>> 24); }",
	"GetCurrentTime"                       => "alias GetTickCount GetCurrentTime;",
	"GetFreeSpace"                         => "",
	"GetGValue"                            => "BYTE GetGValue(COLORREF rgb){ return cast(BYTE)(rgb >>> 8); }",
	"GetKValue"                            => "BYTE GetKValue(DWORD cmyk){ return cast(BYTE)cmyk; }",
	"GetMValue"                            => "BYTE GetMValue(DWORD cmyk){ return cast(BYTE)(cmyk >>> 16); }",
	"GetNextWindow"                        => "",
	"GetRValue"                            => "BYTE GetRValue(COLORREF rgb){ return cast(BYTE)rgb; }",
	"GetScode"                             => "",
	"GetSysModalWindow"                    => "",
	"GetWindowTask"                        => "",
	"GetYValue"                            => "BYTE GetYValue(DWORD cmyk){ return cast(BYTE)(cmyk >>> 8); }",
	"GlobalDiscard"                        => "", 
	"GlobalLRUNewest"                      => "", 
	"GlobalLRUOldest"                      => "",
	"HANDLE_WM_NOTIFY"                     => "",
	"HDITEM_V1_SIZE"                       => "",
	"HDITEMA_V1_SIZE"                      => "",
	"HDITEMW_V1_SIZE"                      => "",
	"HEAP_MAKE_TAG_FLAGS"                  => "uint HEAP_MAKE_TAG_FLAGS(uint b, uint o){ return b + (o << 18); }",
	"HFILE_ERROR"                          => "const HFILE HFILE_ERROR = -1;",
	"HGDI_ERROR"                           => "const HANDLE HGDI_ERROR = cast(HANDLE)(0xFFFFFFFFL);",
	"HIBYTE"                               => "ubyte HIBYTE(ushort l){ return l >>> 8; }",
	"HIWORD"                               => "ushort HIWORD(uint l){ return l >>> 16; }",
	"HINST_COMMCTRL"                       => "HINSTANCE HINST_COMMCTRL = cast(HINSTANCE)(-1);",
	"HRESULT_CODE"                         => "",
	"HRESULT_FACILITY"                     => "", 
	"HRESULT_FROM_NT"                      => "",
	"HRESULT_FROM_SETUPAPI"                => "",
	"HRESULT_FROM_WIN32"                   => "",
	"HRESULT_SEVERITY"                     => "", 
	"HasOverlappedIoCompleted"             => "bit HasOverlappedIoCompleted(LPOVERLAPPED lpOverlapped){ return (*lpOverlapped).Internal != STATUS_PENDING; }",
	"IMAGELISTDRAWPARAMS_V3_SIZE"          => "",
	"IMAGE_FIRST_SECTION"                  => "",
	"IMAGE_ORDINAL"                        => "alias IMAGE_ORDINAL32 IMAGE_ORDINAL;",
	"IMAGE_ORDINAL32"                      => "uint IMAGE_ORDINAL32(uint Ordinal){ return Ordinal & 0xffff; }",
	"IMAGE_ORDINAL64"                      => "ulong IMAGE_ORDINAL64(ulong Ordinal){ return Ordinal & 0xffff; }",
	"IMAGE_ORDINAL_FLAG64"                 => "const ulong IMAGE_ORDINAL_FLAG64 = 0x8000000000000000;",
	"IMAGE_SNAP_BY_ORDINAL"                => "alias IMAGE_SNAP_BY_ORDINAL32 IMAGE_SNAP_BY_ORDINAL;",
	"IMAGE_SNAP_BY_ORDINAL32"              => "bit IMAGE_SNAP_BY_ORDINAL32(uint Ordinal){ return (Ordinal & IMAGE_ORDINAL_FLAG32) != 0; }",
	"IMAGE_SNAP_BY_ORDINAL64"              => "bit IMAGE_SNAP_BY_ORDINAL64(ulong Ordinal){ return (Ordinal & IMAGE_ORDINAL_FLAG64) != 0; }",
	"INCREF"                               => "uint INCREF(uint x){ return ((x&~N_BTMASK)<<N_TSHIFT)|(IMAGE_SYM_DTYPE_POINTER<<N_BTSHFT)|(x&N_BTMASK); }",
	"INDEXTOOVERLAYMASK"                   => "uint INDEXTOOVERLAYMASK(uint i){ return i << 8; }",
	"INDEXTOSTATEIMAGEMASK"                => "uint INDEXTOSTATEIMAGEMASK(uint i){ return i << 12; }",
	"INS_IMM64"                            => "",
	"interface"                            => "",
	"INVALID_ATOM"                         => "enum : ATOM { INVALID_ATOM = 0 }",
	"INVALID_HANDLE_VALUE"                 => "HANDLE INVALID_HANDLE_VALUE = cast(HANDLE)-1;",
	"ISARY"                                => "bit ISARY(uint x){ return (x & N_TMASK) == (IMAGE_SYM_DTYPE_ARRAY << N_BTSHFT); }",
	"ISFCN"                                => "bit ISFCN(uint x){ return (x & N_TMASK) == (IMAGE_SYM_DTYPE_FUNCTION << N_BTSHFT); }",
	"ISPTR"                                => "bit ISPTR(uint x){ return (x & N_TMASK) == (IMAGE_SYM_DTYPE_POINTER << N_BTSHFT); }",
	"ISTAG"                                => "bit ISTAG(uint x){ return x == IMAGE_SYM_CLASS_STRUCT_TAG || x == IMAGE_SYM_CLASS_UNION_TAG || x == IMAGE_SYM_CLASS_ENUM_TAG; }",
	"IS_ERROR"                             => "", 
	"IS_INTRESOURCE"                       => "bit IS_INTRESOURCE(LPTSTR _r){ return ((cast(ULONG_PTR)(_r) >> 16) == 0); }",
	"ImageList_AddIcon"                    => "",
	"ImageList_ExtractIcon"                => "",
	"ImageList_LoadBitmap"                 => "",
	"ImageList_RemoveAll"                  => "",
	"INADDR_ANY"                           => "enum : uint { INADDR_ANY = 0 }",
	"INADDR_BROADCAST"                     => "",
	"INADDR_NONE"                          => "enum : uint { INADDR_NONE = uint.max }",
	"Int32x32To64"                         => "long Int32x32To64(int a, int b) { return (cast(long)a) * b; }",
	"InterlockedExchangePointer"           => "void* InterlockedExchangePointer(void** t, void* v){ return cast(void*)InterlockedExchange(cast(PLONG)t, cast(LONG)v); }",
	"IsReparseTagMicrosoft"                => "",
	"IsReparseTagNameSurrogate"            => "",
	"INVALID_SOCKET"                       => "enum : uint { INVALID_SOCKET = uint.max }",
	"IN_CLASSA"                            => "",
	"IN_CLASSB"                            => "",
	"IN_CLASSB_NET"                        => "",
	"IN_CLASSB_NSHIFT"                     => "",
	"IN_CLASSC"                            => "",
	"IN_CLASSC_NET"                        => "",
	"IN_CLASSC_NSHIFT"                     => "",
	"KEY_EXECUTE"                          => "enum : uint { KEY_EXECUTE = KEY_READ & ~SYNCHRONIZE }",
	"LANGIDFROMLCID"                       => "WORD LANGIDFROMLCID(LCID lcid) { return lcid; }",
	"LANG_SYSTEM_DEFAULT"                  => "enum : uint { LANG_SYSTEM_DEFAULT = (SUBLANG_SYS_DEFAULT << 10) | LANG_NEUTRAL }",
	"LANG_USER_DEFAULT"                    => "enum : uint { LANG_USER_DEFAULT = (SUBLANG_DEFAULT << 10) | LANG_NEUTRAL }",
	"LCS_SIGNATURE"                        => "",
	"LCS_WINDOWS_COLOR_SPACE"              => "",
	"LCS_sRGB"                             => "",
	"LOBYTE"                               => "ubyte LOBYTE(ushort l){ return l & 0xff; }",
	"LOCALE_INVARIANT"                     => "enum : uint { LOCALE_INVARIANT = (SORT_DEFAULT << 16) | (SUBLANG_NEUTRAL << 10) | LANG_INVARIANT }",
	"LOCALE_NEUTRAL"                       => "enum : uint { LOCALE_NEUTRAL = (SORT_DEFAULT << 16) | (SUBLANG_NEUTRAL << 10) | LANG_NEUTRAL }",
	"LOCALE_SYSTEM_DEFAULT"                => "enum : uint { LOCALE_SYSTEM_DEFAULT = (SORT_DEFAULT << 16) | LANG_SYSTEM_DEFAULT }",
	"LOCALE_USER_DEFAULT"                  => "enum : uint { LOCALE_USER_DEFAULT = (SORT_DEFAULT << 16) | LANG_USER_DEFAULT }",
	"LOCALSERVICE_LUID"                    => "const LUID LOCALSERVICE_LUID = {LowPart: 0x3e5, HighPart: 0x0};",
	"LOWORD"                               => "ushort LOWORD(uint l){ return l & 0xffff; }",
	"L_MAX_URL_LENGTH"                     => "enum { L_MAX_URL_LENGTH = 2048 + 32 + 4 }",
	"LimitEmsPages"                        => "",
	"LISet32"                              => "",
	"LocalDiscard"                         => "",
	"LockSegment"                          => "",
	"LVITEM_V1_SIZE"                       => "",
	"LVITEMA_V1_SIZE"                      => "",
	"LVITEMW_V1_SIZE"                      => "",
	"LVHITTESTINFO_V1_SIZE"                => "",
	"LVCOLUMN_V1_SIZE"                     => "",
	"LVCOLUMNA_V1_SIZE"                    => "",
	"LVCOLUMNW_V1_SIZE"                    => "",
	"MAKEFOURCC"                           => "uint MAKEFOURCC(ubyte ch0, ubyte ch1, ubyte ch2, ubyte ch3){ return ch0 | (ch1 << 8) | (ch2 << 16) | (ch3 << 24); }",
	"MAKEINTATOM"                          => "",
	"MAKEINTRESOURCEA"                     => "LPSTR MAKEINTRESOURCEA(WORD i){ return cast(LPSTR)(cast(ULONG_PTR)(cast(WORD)(i))); }",
	"MAKEINTRESOURCEW"                     => "LPWSTR MAKEINTRESOURCEW(WORD i){ return cast(LPWSTR)(cast(ULONG_PTR)(cast(WORD)(i))); }",
	"MAKELANGID"                           => "WORD MAKELANGID(USHORT p, USHORT s) { return (((cast(WORD)(s)) << 10) | cast(WORD)(p)); }",
	"MAKELCID"                             => "DWORD MAKELCID(WORD lgid, WORD srtid) { return ((cast(DWORD)srtid) << 16) | (cast(DWORD)lgid); }",
	"MAKELONG"                             => "uint MAKELONG(ushort a, ushort b){ return (a & 0xffff) | ((b & 0xffff) << 16); }",
	"MAKELPARAM"                           => "alias MAKELONG MAKELPARAM;",
	"MAKELRESULT"                          => "alias MAKELONG MAKELRESULT;",
	"MAKEPOINTS"                           => "",
	"MAKEROP4"                             => "DWORD MAKEROP4(DWORD fore, DWORD back){ return ((back << 8) & 0xFF000000) | fore; }",
	"MAKESORTLCID"                         => "DWORD MAKESORTLCID(WORD lgid, WORD srtid, WORD ver) { return (MAKELCID(lgid, srtid)) | ((cast(DWORD)ver) << 20); }",
	"MAKEWORD"                             => "ushort MAKEWORD(byte a, byte b){ return (a & 0xff) | ((b & 0xff) << 8); }",
	"MAKEWPARAM"                           => "alias MAKELONG MAKEWPARAM;",
	"MAKE_HRESULT"                         => "", 
	"MAKE_SCODE"                           => "",
	"MCI_HMS_HOUR"                         => "",
	"MCI_HMS_MINUTE"                       => "",
	"MCI_HMS_SECOND"                       => "",
	"MCI_MAKE_HMS"                         => "",
	"MCI_MAKE_MSF"                         => "",
	"MCI_MAKE_TMSF"                        => "",
	"MCI_MSF_FRAME"                        => "",
	"MCI_MSF_MINUTE"                       => "",
	"MCI_MSF_SECOND"                       => "",
	"MCI_TMSF_FRAME"                       => "",
	"MCI_TMSF_MINUTE"                      => "",
	"MCI_TMSF_SECOND"                      => "",
	"MCI_TMSF_TRACK"                       => "",
	"MEVT_EVENTPARM"                       => "",
	"MEVT_EVENTTYPE"                       => "",
	"MIN_ACL_REVISION"                     => "enum { MIN_ACL_REVISION = 2 }",
	"MakeProcInstance"                     => "", 
	"MAKEIPRANGE"                          => "",
	"MAKEIPADDRESS"                        => "",
	"NEAR"                                 => "",
	"NETWORKSERVICE_LUID"                  => "const LUID NETWORKSERVICE_LUID = {LowPart: 0x3e4, HighPart: 0x0};",
	"NEXTRAWINPUTBLOCK"                    => "",
	"NM_FIRST"                             => "",
	"NMTTDISPINFO_V1_SIZE"                 => "",
	"NMTTDISPINFO_V3_SIZE"                 => "",
	"NMTTDISPINFOA_V1_SIZE"                => "",
	"NMTTDISPINFOW_V1_SIZE"                => "",
	"NMLVCUSTOMDRAW_V3_SIZE"               => "",
	"NMTVCUSTOMDRAW_V3_SIZE"               => "",
	"NOTIFYICONDATAA_V1_SIZE"              => "",
	"NOTIFYICONDATAA_V2_SIZE"              => "",
	"NOTIFYICONDATAW_V1_SIZE"              => "",
	"NOTIFYICONDATAW_V2_SIZE"              => "",
	"NOTIFYICONDATA_V1_SIZE"               => "",
	"NOTIFYICONDATA_V2_SIZE"               => "",
	"NTAPI"                                => "",
	"NTSYSAPI"                             => "",
	"NTSYSCALLAPI"                         => "",
	"NULL"                                 => "const void* NULL = null;",
	"OPENFILENAME_SIZE_VERSION_400"        => "",
	"OPENFILENAME_SIZE_VERSION_400A"       => "",
	"OPENFILENAME_SIZE_VERSION_400W"       => "",
	"PALETTEINDEX"                         => "COLORREF PALETTEINDEX(WORD i){ return (cast(COLORREF)(0x01000000 | cast(DWORD)cast(WORD)(i))); }",
	"PALETTERGB"                           => "COLORREF PALETTERGB(BYTE r, BYTE g, BYTE b){ return (0x02000000 | RGB(r,g,b)); }",
	"PASCAL"                               => "",
	"POINTER_32"                           => "alias void* POINTER_32;",
	"POINTSTOPOINT"                        => "",
	"POINTTOPOINTS"                        => "",
	"PRIMARYLANGID"                        => "WORD PRIMARYLANGID(WORD lgid) { return lgid & 0x3ff; }",
	"PROBE_ALIGNMENT"                      => "",
	"PROFILE_EMBEDDED"                     => "",
	"PROFILE_LINKED"                       => "",
	"PROPSHEETHEADER_V1_SIZE"              => "",
	"PROPSHEETHEADER_V2_SIZE"              => "",
	"PROPSHEETHEADERA_V1_SIZE"             => "",
	"PROPSHEETHEADERA_V2_SIZE"             => "",
	"PROPSHEETHEADERW_V1_SIZE"             => "",
	"PROPSHEETHEADERW_V2_SIZE"             => "",
	"PROPSHEETPAGEA_V1_FIELDS"             => "",
	"PROPSHEETPAGE_V1_SIZE"                => "",
	"PROPSHEETPAGE_V2_SIZE"                => "",
	"PROPSHEETPAGEA_V1_SIZE"               => "",
	"PROPSHEETPAGEA_V2_SIZE"               => "",
	"PROPSHEETPAGEW_V1_FIELDS"             => "",
	"PROPSHEETPAGEW_V1_SIZE"               => "",
	"PROPSHEETPAGEW_V2_SIZE"               => "",
	"PostAppMessageA"                      => "alias PostThreadMessageA PostAppMessageA;",
	"PostAppMessageW"                      => "alias PostThreadMessageW PostAppMessageW;",
	"PropSheet_AddPage"                    => "",
	"PropSheet_Apply"                      => "",
	"PropSheet_CancelToClose"              => "",
	"PropSheet_Changed"                    => "",
	"PropSheet_GetCurrentPageHwnd"         => "",
	"PropSheet_GetResult"                  => "",
	"PropSheet_GetTabControl"              => "",
	"PropSheet_HwndToIndex"                => "",
	"PropSheet_IdToIndex"                  => "",
	"PropSheet_IndexToHwnd"                => "",
	"PropSheet_IndexToId"                  => "",
	"PropSheet_IndexToPage"                => "",
	"PropSheet_InsertPage"                 => "",
	"PropSheet_IsDialogMessage"            => "",
	"PropSheet_PageToIndex"                => "",
	"PropSheet_PressButton"                => "",
	"PropSheet_QuerySiblings"              => "",
	"PropSheet_RebootSystem"               => "",
	"PropSheet_RecalcPageSizes"            => "",
	"PropSheet_RemovePage"                 => "",
	"PropSheet_RestartWindows"             => "",
	"PropSheet_SetCurSel"                  => "",
	"PropSheet_SetCurSelByID"              => "",
	"PropSheet_SetFinishText"              => "",
	"PropSheet_SetHeaderSubTitle"          => "",
	"PropSheet_SetHeaderTitle"             => "",
	"PropSheet_SetTitle"                   => "",
	"PropSheet_SetWizButtons"              => "",
	"PropSheet_UnChanged"                  => "",
	"PropagateResult"                      => "",
	"PURE"                                 => "",
	"QS_HOTKEY"                            => "",
	"QS_INPUT"                             => "",
	"QS_PAINT"                             => "",
	"QS_POSTMESSAGE"                       => "",
	"QS_SENDMESSAGE"                       => "",
	"QS_TIMER"                             => "",
	"RAWINPUT_ALIGN"                       => "uint RAWINPUT_ALIGN(uint x){ return ((x + DWORD.sizeof - 1) & ~(DWORD.sizeof - 1)); }",
	"REPARSE_GUID_DATA_BUFFER_HEADER_SIZE" => "",
	"RGB"                                  => "COLORREF RGB(BYTE r, BYTE g, BYTE b){ return r|(g <<8)|(b << 16); }",
	"RIDEV_EXMODE"                         => "",
	"RTL_BITS_OF"                          => "",
	"RTL_BITS_OF_FIELD"                    => "",
	"RTL_CONST_CAST"                       => "",
	"RTL_CONTAINS_FIELD"                   => "",
	"RTL_FIELD_SIZE"                       => "",
	"RTL_FIELD_TYPE"                       => "",
	"RTL_NUMBER_OF"                        => "",
	"RTL_NUMBER_OF_FIELD"                  => "",
	"RTL_PADDING_BETWEEN_FIELDS"           => "",
	"RTL_SIZEOF_THROUGH_FIELD"             => "",
	"REBARBANDINFO_V3_SIZE"                => "",
	"REBARBANDINFOA_V3_SIZE"               => "",
	"REBARBANDINFOW_V3_SIZE"               => "",
	"ResultFromScode"                      => "", 
	"RtlCopyMemory"                        => "void RtlCopyMemory(void* d, void* s, uint len){ memcpy(d, s, len); }", 
	"RtlEqualMemory"                       => "bit RtlEqualMemory(void* x, void* y, uint len){ return memcmp(x, y, len) == 0; }",
	"RtlFillMemory"                        => "void RtlFillMemory(void* d, uint len, ubyte f){ memset(d, f, len); }", 
	"RtlMoveMemory"                        => "void RtlMoveMemory(void* d, void* s, uint len){ memmove(d, s, len); }", 
	"RtlZeroMemory"                        => "void RtlZeroMemory(void* d, uint len){ memset(d, 0, len); }", 
	"SB_GETTIPTEXTA"                       => "",
	"SB_GETTIPTEXTW"                       => "",
	"SB_SETTIPTEXTA"                       => "",
	"SB_SETTIPTEXTW"                       => "",
	"SCODE_CODE"                           => "", 
	"SCODE_FACILITY"                       => "",
	"SCODE_SEVERITY"                       => "",
	"SECOND_IPADDRESS"                     => "",
	"SECURITY_CREATOR_SID_AUTHORITY"       => "",
	"SECURITY_LOCAL_SID_AUTHORITY"         => "",
	"SECURITY_NON_UNIQUE_AUTHORITY"        => "",
	"SECURITY_NT_AUTHORITY"                => "",
	"SECURITY_NULL_SID_AUTHORITY"          => "",
	"SECURITY_RESOURCE_MANAGER_AUTHORITY"  => "",
	"SECURITY_WORLD_SID_AUTHORITY"         => "",
	"SHDOCAPI"                             => "",
	"SHDOCAPI_"                            => "",
	"SHSTDAPI"                             => "",
	"SHSTDAPI_"                            => "",
	"SIOCATMARK"                           => "",
	"SIOCGHIWAT"                           => "",
	"SIOCSHIWAT"                           => "",
	"SIOCGLOWAT"                           => "",
	"SIOCSLOWAT"                           => "",
	"SNDMSG"                               => "",
	"SND_ALIAS_SYSTEMASTERISK"             => "",
	"SND_ALIAS_SYSTEMDEFAULT"              => "",
	"SND_ALIAS_SYSTEMEXCLAMATION"          => "",
	"SND_ALIAS_SYSTEMEXIT"                 => "",
	"SND_ALIAS_SYSTEMHAND"                 => "",
	"SND_ALIAS_SYSTEMQUESTION"             => "",
	"SND_ALIAS_SYSTEMSTART"                => "",
	"SND_ALIAS_SYSTEMWELCOME"              => "",
	"SORTIDFROMLCID"                       => "WORD SORTIDFROMLCID(LCID lcid) { return (cast(DWORD)lcid >>> 16) & 0xf; }",
	"SORTVERSIONFROMLCID"                  => "WORD SORTVERSIONFROMLCID(LCID lcid) { return (cast(DWORD)lcid >>> 20) & 0xf; }",
	"SO_DONTLINGER"                        => "enum : uint { SO_DONTLINGER = ~SO_LINGER }",
	"STDAPI"                               => "",
	"STDAPICALLTYPE"                       => "",
	"STDAPIV"                              => "", 
	"STDAPIVCALLTYPE"                      => "",
	"STDAPIV_"                             => "",
	"STDAPI_"                              => "", 
	"STDMETHOD"                            => "",
	"STDMETHOD_"                           => "",
	"STDMETHODCALLTYPE"                    => "",
	"STDMETHODIMP"                         => "",
	"STDMETHODIMPV"                        => "",
	"STDMETHODIMPV_"                       => "",
	"STDMETHODIMP_"                        => "",
	"STDMETHODV"                           => "",
	"STDMETHODV_"                          => "",
	"STDMETHODVCALLTYPE"                   => "",
	"SUBLANGID"                            => "WORD SUBLANGID(WORD lgid) { return lgid >>> 10; }",
	"SUCCEEDED"                            => "bit SUCCEEDED(HRESULT Status){ return Status >= 0; }",
	"SYSTEM_LUID"                          => "const LUID SYSTEM_LUID = {LowPart: 0x3e7, HighPart: 0x0};",
	"SetSwapAreaSize"                      => "",
	"SetSysModalWindow"                    => "",
	"TEXT"                                 => "TCHAR[] TEXT(TCHAR[] quote){ return quote; }",
	"THIRD_IPADDRESS"                      => "",
	"THIS"                                 => "",
	"TYPE_ALIGNMENT"                       => "",
	"TTTOOLINFO_V1_SIZE"                   => "",
	"TTTOOLINFO_V2_SIZE"                   => "",
	"TTTOOLINFO_V3_SIZE"                   => "",
	"TTTOOLINFOA_V1_SIZE"                  => "",
	"TTTOOLINFOW_V1_SIZE"                  => "",
	"TTTOOLINFOA_V2_SIZE"                  => "",
	"TTTOOLINFOW_V2_SIZE"                  => "",
	"TTTOOLINFOA_V3_SIZE"                  => "",
	"TTTOOLINFOW_V3_SIZE"                  => "",
	"TVINSERTSTRUCT_V1_SIZE"               => "",
	"TVINSERTSTRUCTA_V1_SIZE"              => "",
	"TVINSERTSTRUCTW_V1_SIZE"              => "",
	"TVI_ROOT"                             => "const HTREEITEM TVI_ROOT = cast(HTREEITEM)(-0x10000);",
	"TVI_FIRST"                            => "const HTREEITEM TVI_FIRST = cast(HTREEITEM)(-0x0FFFF);",
	"TVI_LAST"                             => "const HTREEITEM TVI_LAST = cast(HTREEITEM)(-0x0FFFE);",
	"TVI_SORT"                             => "const HTREEITEM TVI_SORT = cast(HTREEITEM)(-0x0FFFD);",
	"TVHT_ONITEMSTATEICON"                 => "",
	"UInt32x32To64"                        => "ulong UInt32x32To64(uint a, uint b) { return (cast(ulong)a) * b; }",
	"ULISet32"                             => "",
	"UNREFERENCED_PARAMETER"               => "",
	"UnlockResource"                       => "", 
	"UnlockSegment"                        => "",
	"VALID_IMPERSONATION_LEVEL"            => "bit VALID_IMPERSONATION_LEVEL(SECURITY_IMPERSONATION_LEVEL L){ return (L >= SECURITY_MIN_IMPERSONATION_LEVEL) && (L <= SECURITY_MAX_IMPERSONATION_LEVEL); }",
	"VERIFIER_STOP"                        => "",
	"VER_SET_CONDITION"                    => "",
	"WAIT_ABANDONED"                       => "alias STATUS_ABANDONED_WAIT_0 WAIT_ABANDONED;",
	"WAIT_ABANDONED_0"                     => "alias STATUS_ABANDONED_WAIT_0 WAIT_ABANDONED_0;",
	"WAIT_OBJECT_0"                        => "alias STATUS_WAIT_0 WAIT_OBJECT_0;",
	"WC_DIALOG"                            => "const ATOM WC_DIALOG = cast(ATOM)0x8002;",
	"WINADVAPI"                            => "",
	"WINAPI"                               => "",
	"WINAPIV"                              => "",
	"WINBASEAPI"                           => "",
	"WINCOMMCTRLAPI"                       => "",
	"WINCOMMDLGAPI"                        => "",
	"WINGDIAPI"                            => "",
	"WINMMAPI"                             => "",
	"WINOLEAPI"                            => "",
	"WINOLEAPI_"                           => "",
	"WINSHELLAPI"                          => "",
	"WINSPOOLAPI"                          => "",
	"WINUSERAPI"                           => "",
	"WSAMAKEASYNCREPLY"                    => "",
	"WSAMAKESELECTREPLY"                   => "",
	"WSAGETASYNCBUFLEN"                    => "",
	"WSAGETASYNCERROR"                     => "",
	"WSAGETSELECTEVENT"                    => "",
	"WSAGETSELECTERROR"                    => "",
	"WS_TILEDWINDOW"                       => "",
	"WT_SET_MAX_THREADPOOL_THREADS"        => "",
	"Yield"                                => "",
	"ZAWPROXYAPI"                          => "",
	"_PROPSHEETPAGEA_V3"   => "alias _PROPSHEETPAGEA_V3 _PROPSHEETPAGEA;",
	"_PROPSHEETPAGEW_V3"   => "alias _PROPSHEETPAGEW_V3 _PROPSHEETPAGEW;",
	"_HRESULT_TYPEDEF_"    => "",
	"__HRESULT_FROM_WIN32" => "",
	"__TEXT"               => "",
	"_IO"                  => "",
	"_IOR"                 => "",
	"_IOW"                 => "",
	"cdecl"      => "",
	"h_addr"     => "",
	"h_errno"    => "",
	"max"        => "int max(int a, int b){ return (a > b)? a : b; }\nuint max(uint a, uint b){ return (a > b)? a : b; }\nreal max(real a, real b){ return (a > b)? a : b; }",
	"min"        => "int min(int a, int b){ return (a < b)? a : b; }\nuint min(uint a, uint b){ return (a < b)? a : b; }\nreal min(real a, real b){ return (a < b)? a : b; }",
	"mmioFOURCC" => "",
	"pascal"     => "",
	"sndAlias"   => "",
	"s_addr"     => "",
	"s_host"     => "",
	"s_imp"      => "",
	"s_impno"    => "",
	"s_lh"       => "",
	"s_net"      => "",
	"timerclear" => "",
	"timercmp"   => "",
	"timerisset" => "",
	"D3DAPI" => "",
	"D3DXINLINE" => "");

%duplicated_union = (
	"_LARGE_INTEGER"   => 1,
	"_ULARGE_INTEGER"  => 1,
	"tagMIXERCONTROLA" => 1,
	"tagMIXERCONTROLW" => 1);

$debug_ifdef = 0;

#--------------------------------------------------

$is_DirectX = 0;
$target_header = $sdk_path . $ARGV[0];
if(!(-e $target_header)){
	$is_DirectX = 1;
	$target_header = $dx_path . $ARGV[0];
	if(!(-e $target_header)){
		print $ARGV[0]." does not exists. \n";
		die;
	}
}

$option_inline = $ARGV[1] eq "-inline";

$directory = exists $define{"UNICODE"} ? "win32" : "win32.ansi" ;

if(!($target_header =~ /([a-z0-9]+).h$/s)){ die; }

if(!$option_inline){
	if($is_DirectX){
		print <<EOT
module $directory.directx.$1;

// Translated from Microsoft DirectX 8.0 (C++)
// by Y.Tomino (demoonlit\@inter7.jp)

EOT
	}else{
		print <<EOT
module $directory.$1;

// Translated from Microsoft Platform SDK August 2001 Edition
// by Y.Tomino (demoonlit\@inter7.jp)

EOT
	}
}

if($1 eq "windows"){
	$include{"ole2"} = "";
	$include{"winsock"} = "";
}elsif($1 eq "winnt"){
	print <<EOT
import $directory.windef;
alias void _TEB;
alias void _EXCEPTION_REGISTRATION_RECORD;
private extern(C) {
  int memcmp(void*, void*, uint);
  void* memmove(void*, void*, uint);
  void* memcpy(void*, void*, uint);
  void* memset(void*, uint, uint);
}
EOT
}elsif($1 eq "windef"){
	print <<EOT
alias void* va_list;
alias long __int64;
alias ulong DWORD64;
alias uint SIZE_T;
alias SIZE_T* PSIZE_T;
alias int INT_PTR;
alias uint UINT_PTR;
alias uint LONG_PTR;
alias uint ULONG_PTR;
alias uint DWORD_PTR;
alias DWORD_PTR* PDWORD_PTR;
alias UINT_PTR* PUINT_PTR;
alias ULONG_PTR* PULONG_PTR;
enum : UINT { UINT_MAX = UINT.max }
EOT
}elsif($1 eq "winbase"){
	print "import $directory.windef;\n";
}elsif($1 eq "winerror"){
	print "import $directory.winnt;\n";
}elsif($1 eq "wingdi"){
	print "import $directory.windef;\n";
}elsif($1 eq "winuser"){
	print <<EOT
import $directory.winbase, $directory.wingdi;
enum : uint {
  QS_POSTMESSAGE = 0x0008,
  QS_TIMER       = 0x0010,
  QS_PAINT       = 0x0020,
  QS_SENDMESSAGE = 0x0040,
  QS_HOTKEY      = 0x0080,
  QS_INPUT       = 0x0407
}
EOT
}elsif($1 eq "winnls"){
	print "import $directory.winbase;\n";
}elsif($1 eq "wincon"){
	print "import $directory.winbase;\n";
}elsif($1 eq "winver"){
	print "import $directory.winuser;\n";
}elsif($1 eq "winreg"){
	print "import $directory.winnt, $directory.winbase;\n";
}elsif($1 eq "ddeml"){
	print "import $directory.windef;\n";
}elsif($1 eq "dlgs"){
	print "import $directory.windef;\n";
}elsif($1 eq "mmsystem"){
	print "import $directory.winbase;\n";
}elsif($1 eq "shellapi"){
	print "import $directory.winuser;\n";
}elsif($1 eq "winspool"){
	print "import $directory.winbase, $directory.wingdi;\n";
}elsif($1 eq "commdlg"){
	print "import $directory.winuser;\n";
	&inline("cderr");
}elsif($1 eq "imm"){
	print "import $directory.winuser;\n";
}elsif($1 eq "commctrl"){
	print <<EOT
import $directory.winuser;
alias void _PSP;
alias void _IMAGELIST;
alias void _TREEITEM;
alias LPTBSAVEPARAMW LPTBSAVEPARAMSW;
alias PCCOMBOEXITEMA PCCOMBOBOXEXITEMA;
alias PCCOMBOEXITEMW PCCOMBOBOXEXITEMW;
enum : uint { 
  NM_FIRST = 0,
  SB_SETTIPTEXTA = WM_USER + 16,
  SB_SETTIPTEXTW = WM_USER + 17,
  SB_GETTIPTEXTA = WM_USER + 18,
  SB_GETTIPTEXTW = WM_USER + 19,
  TVHT_ONITEMSTATEICON = 0x0040,
  CBEN_FIRST = 0U - 800U,
  CBEN_GETDISPINFOA = CBEN_FIRST - 0,
  CBEN_GETDISPINFOW = CBEN_FIRST - 7
}
EOT
	;
	$define{"__IID_DEFINED__"} = 1;
	$define{"WM_MOUSEHOVER"} = 1;
	&inline("prsht");
}elsif($1 eq "objbase"){
	print "import $directory.wtypes;\n";
	$include{"wtypes"} = "";
}

$src = "";
open(H, "< " . $target_header) or ((print STDERR "---- File not found.\n"), die);
while (read(H, $data, 4096) > 0){ $src = $src.$data; }
close(H);

@ifdef = [];   #-1,0,1̔zAI[1̎R[h
$ifdef_ok = 1; # @ifdefω&ifdef_ok_testĂ

sub ifdef_ok_test {
	foreach $i (@ifdef) {
		if($i <= 0){ 
			$ifdef_ok = 0; 
			return 0; 
		}
	}
	$ifdef_ok = 1; 
	return 1;
}

sub inline {
	$h = $_[0];
	print "// inline #include <$h.h>\n";
	print "// ----\n";
	open(IN, "perl _win32sdk2d.pl $h.h -inline |") or die;
	while (<IN>) { print $_; }
	close(IN);
	print "// ----\n";
}

@cur = []; # ""cȂ "*"ctB[h c^

$dummy = 0;

sub report_error {
	@s = split(/\n/, $src);
	print STDERR "---- Error !\n";
	print STDERR $s[0] . "\n" . $s[1] . "\n" . $s[2] . "\n----\n";
}

while($src ne ""){
	if($src =~ /^(?: *(?:[\n\x0c]|\/\*(?:.|\n)*?\*\/|\/\/.*?\n))+/){
		#s
		print "\n"; 
		$src = $';
	}elsif($src =~ /^ *\#if/){
		#if, #ifdef, #ifndef
		if($src =~ /^ *\#ifdef +([A-Za-z_0-9]+?) *(?:\/\*.*?\*\/ *)?(?:\/\/.*?)?\n/){
			#ifdef
			print "// $&";
			if(defined($define{$1})){
				push(@ifdef, 1);
				# $ifdef_ok͈ێ
			}else{
				push(@ifdef, 0);
				$ifdef_ok = 0;
			}
			$src = $';
		}elsif($src =~ /^\s*\#ifndef +([A-Za-z_0-9]+?) *(?:\/\*.*?\*\/ *)?(?:\/\/.*?)?\n/){
			#ifndef
			print "// $&";
			if(defined($define{$1})){
				push(@ifdef, 0);
				$ifdef_ok = 0;
			}else{
				push(@ifdef, 1);
				# $ifdef_ok͈ێ
			}
			$src = $';
		}elsif($src =~ /^\#if +(.+?)\n/ || $src =~ /^ *\#if *\((.+?)\) *\n/){
			#if
			print "// $&";
			$src = $';
			$e = $1;
			#print STDERR $e ."\n";
			$e =~ s/\/\/.*$//;
			$e =~ s/(\b[A-Z_][A-Za-z_0-9]*\b)/\$define\{\"$1\"\}/g;
			#print STDERR $e ."\n";
			#print STDERR eval($e)."\n";
			if(eval($e)){
				push(@ifdef, 1);
				# $ifdef_ok͈ێ
			}else{
				push(@ifdef, 0);
				$ifdef_ok = 0;
			}
		}else{
			&report_error();
			die;
		}
		if($debug_ifdef){
			foreach $j (@ifdef){ print STDERR " "; } print STDERR "if" . $ifdef_ok . "\n";
		}
	}elsif($src =~ /^\#elif/){
		#elif
		if($src =~ /^\#elif +(.+?)\n/ || $src =~ /^\#elif *\((.+?)\)\n/){
			print "// $&";
			$src = $';
			$c = pop(@ifdef);
			if($c == 1){
				push(@ifdef, -1);
				$ifdef_ok = 0;
			}elsif($c == -1){
				push(@ifdef, -1);
				$ifdef_ok = 0;
			}else{
				$e = $1;
				$e =~ s/([A-Z_][A-Za-z_0-9]*)/\$define\{\"$1\"\}/g;
				#print STDERR $e ."\n";
				#print STDERR eval($e)."\n";
				if(eval($e)){
					push(@ifdef, 1);
					&ifdef_ok_test();
				}else{
					push(@ifdef, 0);
					$ifdef_ok = 0;
				}
			}
		}else{
			&report_error();
			die;
		}
		if($debug_ifdef){
			foreach $j (@ifdef){ print STDERR " "; } print STDERR "elsif" . $ifdef_ok . "\n";
		}
	}elsif($src =~ /^ *\#else/){
		#else
		if($src =~ /^ *\#else *(?:\/\*.*?\*\/ *)?(?:\/\/.*?)?\n/){
			print "// $&";
			$c = pop(@ifdef);
			#print STDERR "$c\n";
			if($c == 0){
				push(@ifdef, 1);
			}else{
				push(@ifdef, -1);
			}
			&ifdef_ok_test();
			$src = $';
		}else{
			&report_error();
			die;
		}
		if($debug_ifdef){
			foreach $j (@ifdef){ print STDERR " "; } print STDERR "else" . $ifdef_ok . "\n";
		}
	}elsif($src =~ /^ *\#endif/){
		#endif
		if($debug_ifdef){
			foreach $j (@ifdef){ print STDERR " "; }
		}
		if($src =~ /^ *\#endif[ \t]*(?:\/\*.*?\*\/ *)?(?:\/\/.*?)?\n/){
			print "// $&";
			pop(@ifdef);
			&ifdef_ok_test();
			$src = $';
		}else{
			&report_error();
			die;
		}
		if($debug_ifdef){
			print STDERR "endif" . $ifdef_ok . "\n";
		}
	}elsif(!$ifdef_ok){
		#𖞂Ȃꍇǂݔ΂
		if($src =~ /^ *\#/){
			$src =~ s/^.+?\n//;
			print "// #...\n";
		}else{
			$src =~ s/^(?:[^#\n].*?\n)+//;
			print "// ...\n";
		}
	}elsif($src =~ /^ *\#/){
		# ȊÕvvZX
		if($src =~ /^ *\# *define[ \t]+([A-Za-z_]\w*).*?(?:\/\*(?:.|\n)*?\*\/.*?)?(?:\\\n[^\\\n\r]*)*\n/){
			$src2 = $';
			$def = $1;
			$ds = $&;
			if(!($ds =~ /\".*(?:\/\/|\/\*)/)){
				$ds =~ s/\/\*.*?\*\// /gs;
				$ds =~ s/\/\/.*\n/\n/g;
			}
			$ds =~ s/\\\n/ /g;
			$ds =~ s/\t/ /g;
			$ds =~ s/([^ ]) +/$1 /g;
			$ds =~ s/ *\n//g;
			#print STDERR $ds."\n";
			if($def eq "MF_END" && exists $define{$def}){
				print "// skip $ds\n";
			}elsif(exists $define_replace{$def}){
				$rep = $define_replace{$def};
				if($rep eq ""){
					$define{$1} = $2;
					print "// $ds\n";
				}else{
					print $rep . "\n";
					$define{$1} = $2;
				}
			}elsif($def =~ /^(?:ListView|TreeView|TabCtrl|Animate|MonthCal|DateTime|Header|Pager|Button|Edit|ComboBox)_\w+$/){
				print "// $ds\n";
			}elsif($ds =~ /^\s*\#define\s+([A-Za-z_]\w*)\s+(?:\( *)?((?:0[xX][0-9A-Fa-f_]+|\-?\d+)(?:L|l)?)(?: *\))?$/){
				#define A  ^
				$n = $1;
				$v = $2;
				$v =~ s/L$//i;
				#print STDERR $v."\n";
				$define{$n} = eval($v);
				if($v < 0){
					print "enum { $n = $v }\n";
				}else{
					print "enum : uint { $n = $v }\n";
				}
			}elsif($ds =~ /^\s*\#define\s+([A-Za-z_]\w*)\s+\(?\((BYTE|DWORD|WORD|CHAR|WCHAR)\s*\)\s*\(?(0x[0-9A-Fa-f_]+|\-?\d+)L?\)?$/){
				#define A (unsigned)
				$define{$1} = $3;
				if($3 >= 0){
					print "enum : $2 { $1 = $3 }\n";
				}else{
					print "enum : $2 { $1 = cast($2)$3 }\n";
				}
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +\((SHORT|UINT) *\) *\(?(0x[0-9A-Fa-f_]+L?|\-?\d+)\)?$/){
				#define A (signed)
				$define{$1} = $3;
				print "enum : $2 { $1 = $3 }\n";
			}elsif($ds =~ /^\s*\#define\s+([A-Za-z_]\w*)\s+\(?\((HRESULT)\s*\)\s*\(?(0x[0-9A-Fa-f_]+|\-?\d+)L?\)?$/){
				#define A (always-cast)
				$define{$1} = $3;
				print "enum : $2 { $1 = cast($2)$3 }\n";
			}elsif($ds =~ /^\#define\s+([A-Za-z_]\w*)\s+\(\((HWND|HBITMAP|HKEY)\)\s*(0x[0-9A-Fa-f_]+L?|\-?[0-9]+)\)$/){
				#define A (HANDLE)
				$define{$1} = $3;
				print "const $2 $1 = cast($2)$3;\n";
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +\(\(LPWSTR\)(\-?[0-9]+)L?\)$/){
				#define A (LPWSTR)
				$define{$1} = $2;
				print "const LPWSTR $1 = cast(LPWSTR)$2;\n";
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +\(\(LPSTR\)(\-?[0-9]+)L?\)$/){
				#define A (LPSTR)
				$define{$1} = $2;
				print "const LPSTR $1 = cast(LPSTR)$2;\n";
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +_HRESULT_TYPEDEF_\((.*)\)$/){
				#define A _HRESULT_TYPEDEF_()
				$define{$1} = $2;
				print "enum : HRESULT { $1 = cast(HRESULT)$2 }\n";
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +MAKEINTRESOURCE\((.*)\)$/){
				#define A MAKEINTRESOURCE()
				$define{$def} = $2;
				$e = $2;
				$e =~ s/\(\s*(ULONG_PTR)\s*\)/cast($1)/g;
				print "const LPTSTR $def = cast(LPTSTR)($e);\n";
			}elsif($ds =~ /^\#define ([A-Za-z_]\w*) +sizeof\(([A-Za-z_][A-Za-z_0-9]+)\)$/){
				#define A sizeof(B)
				$define{$1} = 1;
				print "const uint $1 = $2.sizeof;\n";
			}elsif($ds =~ /^\#define ([A-Za-z_]\w*) +(\w+) *\| *(\w+)$/){
				#define A B|C
				$define{$1} = 1;
				print "enum : uint { $1 = $2 | $3 }\n";
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +\(\( *HKEY *\) *(.*)\)$/){
				#define A ((HKEY))
				$define{$def} = $2;
				$e = $2;
				$e =~ s/\(\s*(UINT|BYTE|MCIDEVICEID|HANDLE|DWORD|WORD|HKEY|ULONG_PTR|LONG)\s*\)/cast($1)/g;
				print "const HKEY $def = cast(HKEY)$e;\n";
			}elsif($ds =~ /^\#define +([A-Za-z_]\w*) +\((.*)\)$/){
				#define A ()
				#print STDERR $ds;
				$define{$def} = $2;
				$e = $2;
				if($e =~ /\bsizeof\b/){
					$e =~ s/sizeof\(([A-Z_]+)\)/$1.sizeof/g;
					print "const uint $def = $e;\n";
				}else{
					$e =~ s/\(\s*(UINT|BYTE|MCIDEVICEID|HANDLE|DWORD|WORD|HKEY|ULONG_PTR|LONG)\s*\)/cast($1)/g;
					print "enum : uint { $def = $e }\n";
				}
			}elsif($ds =~ /^\#define ([A-Za-z_]\w*) (\".*\")$/){
				#
				$define{$1} = $2;
				print "const char[] $1 = $2;\n";
			}elsif($ds =~ /^\#define ([A-Za-z_]\w*) L(\".*\")$/){
				#
				$define{$1} = $2;
				print "const wchar[] $1 = $2;\n";
			}elsif($ds =~ /^\#define ([A-Za-z_]\w*) TEXT\((\".*\")\)(?:[ \t]*\/\/.*)?$/){
				#
				$define{$1} = $2;
				print "const TCHAR[] $1 = $2;\n";
			}elsif($ds =~ /^\# *define ([A-Za-z_]\w*) +([A-Za-z_][A-Za-z_0-9]+)$/){
				#define A B
				$define{$1} = $2;
				print "alias $2 $1;\n";
			}elsif($ds =~ /^\# *define ([A-Za-z_]\w*)$/){
				#define A
				print "// $&\n";
				$define{$def} = 1;
			}else{
				&report_error();
				die;
			}
			$src = $src2; 
			$src2 = "";
		}elsif($src =~ /^\#undef +([A-Za-z_]\w*?)\n/){
			#undef
			print "// $&";
			delete $define{$1};
			$src = $';
		}elsif($src =~ /^\#pragma once\n/){
			#pragma once -- 
			print "// $&";
			$src = $';
		}elsif($src =~ /^\#pragma warning *\(.*?\n/){
			#pragma warning -- 
			print "// $&";
			$src = $';
		}elsif($src =~ /^\#pragma function\(.*?\n/){
			#pragma function -- 
			print "// $&";
			$src = $';
		}elsif($src =~ /^\#include [\<\"]([a-z0-9]+).h[\>\"] *(?:\/\*.*?\*\/|\/\/.*?)?\n/){
			#include
			if(exists $include{$1}){
				if($include{$1} eq ""){
					print "// $&";
				}elsif($include{$1} eq "*"){
					&inline($1);
				}else{
					print $include{$1} . "\n";
				}
			}else{
				print "import $directory.$1;\n";
			}
			$src = $';
		}else{
			&report_error();
			die;
		}
	}elsif($src =~ /^ *typedef\b/){
		#typedefQ
		$src =~ /^ *(typedef\b.*?[\;\{])/s;
		$src2 = $';
		$ts = $1;
		$ts =~ s/\/\*.*?\*\// /g;
		$ts =~ s/\n/ /g;
		$ts =~ s/\b(?:unsigned char)\b/ubyte/g;
		$ts =~ s/\b(?:unsigned short)\b/ushort/g;
		$ts =~ s/\b(?:unsigned int)\b/uint/g;
		$ts =~ s/\b(?:unsigned long)\b/uint/g;
		$ts =~ s/\b(?:unsigned __int64)\b/ulong/g;
		$ts =~ s/\b(?:wchar_t)\b/wchar/g;
		$ts =~ s/\b(?:long)\b/int/g;
		$ts =~ s/ +/ /g;
		#print STDERR $ts."\n";
		if($ts =~ /^typedef struct +([A-Za-z_]\w*) *\{$/){
			print "struct $1 {\n";
			push(@cur, $1);
		}elsif($ts =~ /^typedef struct (tagMOUSEHOOKSTRUCTEX) \: public tagMOUSEHOOKSTRUCT *\{$/){
			print "struct $1 {\n";
			print "  POINT pt;\n";
			print "  HWND hwnd;\n";
			print "  UINT wHitTestCode;\n";
			print "  ULONG_PTR dwExtraInfo;\n";
			push(@cur, $1);
		}elsif($ts =~ /^typedef struct (tagMONITORINFOEX[AW]) : public tagMONITORINFO *\{$/){
			print "struct $1 {\n";
			print "  DWORD   cbSize;\n";
			print "  RECT    rcMonitor;\n";
			print "  RECT    rcWork;\n";
			print "  DWORD   dwFlags;\n";
			push(@cur, $1);
		}elsif($ts =~ /^typedef struct *\{$/){
			print "struct _$dummy {\n";
			push(@cur, "_".$dummy);
			++$dummy;
		}elsif($ts =~ /^typedef enum +([A-Za-z_]\w*) *\{$/){
			print "alias int $1;\n";
			print "enum {\n";
			push(@cur, $1);
		}elsif($ts =~ /^typedef enum *\{$/){
			print "enum _$dummy {\n";
			push(@cur, "_".$dummy);
			++$dummy;
		}elsif($ts =~ /^typedef union +([A-Za-z_]\w*) *\{$/){
			print "union $1 {\n";
			push(@cur, $1);
		}elsif($ts =~ /^typedef QUERYHANDLER FAR \*PQUERYHANDLER;$/){
			#(QUERYHANDLER͊֐|C^ᖳc)
			print "extern(Windows) alias DWORD function(LPVOID keycontext, PVALCONTEXT val_list, DWORD num_vals, LPVOID outputbuffer, DWORD* total_outlen, DWORD input_blen) PQUERYHANDLER;\n";
		}elsif($ts =~ /^typedef DRVCALLBACK FAR \*LPDRVCALLBACK;$/){
			#(DRVCALLBACK͊֐|C^ᖳc)
			print "extern(Windows) alias void function(HDRVR hdrvr, UINT uMsg, DWORD_PTR dwUser, DWORD_PTR dw1, DWORD_PTR dw2) LPDRVCALLBACK;\n";
		}elsif($ts =~ /^typedef DRVCALLBACK *\*PDRVCALLBACK;$/){
			#(DRVCALLBACK͊֐|C^ᖳc)
			print "alias LPDRVCALLBACK PDRVCALLBACK;\n";
		}elsif($ts =~ /^typedef DRVCALLBACK \w+;$/){
			#(DRVCALLBACK͊֐|C^ᖳc)
			print "// $&\n";
		}elsif($ts =~ /^typedef (?:WAVECALLBACK|MIDICALLBACK) FAR \*(\w+);$/){
			#(DRVCALLBACK͊֐|C^ᖳc)
			print "alias LPDRVCALLBACK $1;\n";
		}elsif($ts =~ /^typedef TIMECALLBACK FAR \*LPTIMECALLBACK;$/){
			#(TIMECALLBACK͊֐|C^ᖳc)
			print "extern(Windows) alias void function(UINT uTimerID, UINT uMsg, DWORD_PTR dwUser, DWORD_PTR dw1, DWORD_PTR dw2) LPTIMECALLBACK;\n";
		}elsif($ts =~ /^typedef MMIOPROC FAR \*LPMMIOPROC;$/){
			#(MMIOPROC͊֐|C^ᖳc)
			print "extern(Windows) alias LRESULT function(LPSTR lpmmioinfo, UINT uMsg, LPARAM lParam1, LPARAM lParam2) LPMMIOPROC;\n";
		}elsif($ts =~ /^typedef\s+(?:struct\b)?\s*([A-Za-z_]\w*) +([A-Za-z_]\w*(?:\[\w+\])?) *\;$/){
			#typedef A B
			if($2 eq "ACTCTX"){
				print "// skip $&\n";
			}else{
				print "alias $1 $2;\n";
			}
		}elsif($ts =~ /^typedef (?:CONST\b|const\b)? *?(?:struct\b)? *?([A-Za-z_]\w*) *(?:(?:near|far|NEAR|FAR|UNALIGNED|CONST|_huge)\b *)*\* *([A-Z_]\w*) *\;$/){
			#typedef A *B;
			print "alias $1* $2;\n";
		}elsif($ts =~ /^typedef ([A-Z_]+) +([A-Z_]+(?:\[[A-Z_]+\])?)\, *([A-Z_]+(?:\[[A-Z_]+\])?)\;$/){
			#typedef A B, C
			print "alias $1 $2;\n";
			print "alias $1 $3;\n";
		}elsif($ts =~ /^typedef (?:CONST |const )?([A-Za-z_]\w*) *([A-Z_]\w*) *\,\n?(?: near| far| NEAR| FAR)? *\* *([A-Z_]\w*) *\;$/){
			#typedef A B, *C;
			print "alias $1 $2;\n";
			print "alias $1* $3;\n";
		}elsif($ts =~ /^typedef (?:CONST |const )?(?:struct )?((?:tag)?[A-Z]+)(?: near| far| NEAR| FAR| UNALIGNED)? *\* *([A-Z]+)\,(?: FAR)? *\* *([A-Z]+)\;$/){
			#typedef A *B, *C;
			print "alias $1* $2;\n";
			print "alias $1* $3;\n";
		}elsif($ts =~ /^typedef (?:CONST |const )?(?:struct )?((?:tag)?[A-Z]+) *\* *([A-Z]+)\, *(?: NEAR)? *\* *([A-Z]+)\,(?: FAR)? *\* *([A-Z]+)\;$/){
			#typedef A *B, *C, *D;
			print "alias $1* $2;\n";
			print "alias $1* $3;\n";
			print "alias $1* $4;\n";
		}elsif($ts =~ /^typedef ([A-Z_]+) +([A-Z_]+(?:\[[A-Z_]+\])?)\, *([A-Z_]+(?:\[[A-Z_]+\])?)\, *([A-Z_]+(?:\[[A-Z_]+\])?)\, *([A-Z_]+(?:\[[A-Z_]+\])?)\;$/){
			#typedef A B,C,D,E
			print "alias $1 $2;\n";
			print "alias $1 $3;\n";
			print "alias $1 $4;\n";
			print "alias $1 $5;\n";
		}elsif($ts =~ /^typedef (?:CONST |const )?(void)(?: near| far| NEAR| FAR)? *\* POINTER_64 *([A-Z_][A-Z_0-9]*)\;$/){
			#64rbg|C^
			print "deprecated alias $1* $2; /* warning: 64-bit */ \n";
		}elsif($ts =~ /^typedef ([A-Za-z_]+) *\((?:FAR\b *|NEAR\b *|WINAPI\b *|CALLBACK\b *|NTAPI\b *|APIENTRY\b *|STDMETHODCALLTYPE\b *|STDAPICALLTYPE\b *)*\* *([A-Z_]\w*)\) *\((.*?)\) *\;$/){
			#֐|C^
			$r = $1;
			$n = $2;
			$a = $3;
			$a =~ s/\b(?:IN|OUT|OPTIONAL|const|CONST|volatile|struct|FAR|NEAR)\b//g;
			if($a eq "void"){ $a = ""; }
			print "extern(Windows) alias $r function($a) $n;\n";
		}elsif($ts =~ /^typedef ([A-Za-z_]\w*) \(?(?:_cdecl|CALLBACK) ([A-Z_]\w*)\)? *\((.*?)\) *\;$/){
			#u֐vnot |C^
			print "// $&\n";
		}elsif($ts =~ /^typedef interface +I\w* +I\w*\;$/){
			print "// $&\n";
		}else{
			&report_error();
			die;
		}
		$src = $src2;
		$src2 = "";
		$src =~ s/(?: |\/\*.*?\*\/)*(?:\/\/.*?)?\n//;
	}elsif($src =~ /^extern \"C\" *\{(?: *\/\*.*?\*\/)*(?:\/\/.*?)?\n/){
		#extern "C"
		print "// $&";
		push(@cur, "");
		$src = $';
	}elsif($src =~ /^ *struct\n? *\{ *(?:\/\*.*?\*\/|\/\/.*?)?\n/){
		#struct
		$p = pop(@cur);
		push(@cur, $p);
		#print STDERR $p."\n";
		if(exists $duplicated_union{$p}){
			print "struct _$dummy {\n";
			push(@cur, "*_$dummy");
			$src = $';
			++$dummy;
		}else{
			print "struct {\n";
			push(@cur, "*");
			$src = $';
		}
	}elsif($src =~ /^ *struct +\w+\;\n/){
		#forward
		print "// $&";
		$src = $';
	}elsif($src =~ /^ *union ?\n? *\{ *(?:\/\*.*?\*\/|\/\/.*?)?\n/){
		#union
		$p = pop(@cur);
		push(@cur, $p);
		#print STDERR $p."\n";
		if(exists $duplicated_union{$p}){
			print "union _$dummy {\n";
			push(@cur, "*_$dummy");
			$src = $';
			++$dummy;
		}else{
			print "union {\n";
			push(@cur, "*");
			$src = $';
		}
	}elsif($src =~ /^ *struct *([A-Za-z_]\w*) \{\n/){
		#struct
		print "struct $1 {\n";
		push(@cur, $1);
		$src = $';
	}elsif($src =~ /^ *enum *([A-Z]\w*) \{\n/){
		#enum
		print "enum $1 {\n";
		push(@cur, $1);
		$src = $';
	}elsif($src =~ /^ *\}((?:[A-Za-z0-9_ \*\,\n]|\#if\(WINVER \>\= 0x0500\)|\#endif \/\* WINVER \>\= 0x0500 \*\/)*;)?/s){
		$src = $';
		$p = $1;
		$p =~ s/\#.*?\n/ /g;
		$p =~ s/\n/ /g;
		$c = pop(@cur);
		if($c eq ""){
			print "// $&";
		}elsif($c eq "*"){
			# } 
			print "}\n";
		}elsif($c =~ /^\*(_[0-9]+)$/){
			# } field ;
			$t = $1;
			$p =~ s/ //g;
			#print STDERR $p . "\n";
			if($p =~ /([A-Za-z_0-9]+);/){
				print "}\n";
				print "$t $1;\n";
			}else{
				print "}\n";
				print "$t _;\n";
			}
		}else{
			print "}\n";
			# } *PRECT ; Ȃǂ̏
			$p =~ s/ //g;
			#print STDERR $p.">\n";
			while($p ne "" && $p ne ";"){
				if($p =~ /^\,/){
					$p = $';
				}
				if($p =~ /^(?:FAR|NEAR|far|near)?\*([A-Za-z_][A-Za-z_0-9]*)/){
					print "alias $c* $1;\n";
					$p = $';
				}elsif($p =~ /^([A-Za-z_][A-Za-z_0-9]*)/){
					if($c ne $1){
						print "alias $c $1;\n";
					}
					$p = $';
				}else{
					print STDERR "----" . $p . "\n";
					die;
				}
			}
		}
	}elsif($src =~ /^DECLARE_HANDLE *\(([A-Z]+)\)\;(?: *\/\/.*?| *\/\*.*?\*\/)?\n/){
		# HANDLE̕ʖ
		print "alias void* $1;\n";
		$src = $';
	}elsif($src =~ /^struct +([A-Z_]+) +\*\n([A-Za-z_][A-Za-z_0-9]*)\(void\);\n/){
		#֐
		print "extern(Windows) export $1 $2();\n";
		$src = $';
	}elsif($src =~ /^(?:extern\b|NTSYSAPI\n|WINBASEAPI\n|WINADVAPI\n|WINGDIAPI\b|WINSPOOLAPI\b|WINUSERAPI\b\n?|WINMMAPI\b|WINCOMMDLGAPI\b|WINCOMMCTRLAPI\b\n?)? *(?:DECLSPEC_[A-Z]+\b\n?)?([A-Za-z_]+\b) *\n?(?:NTAPI\b|WINAPIV?\b|APIENTRY\b|PASCAL FAR\b)?\n? *([A-Za-z_]\w*) *\((.*?)\) *\; *(?:\/\*.*?\*\/ *)?(?:\/\/.*?)?\n/s){
		#֐
		$src = $';
		$r = $1;
		$n = $2;
		$a = $3;
		if($r eq "SHSTDAPI" || $r eq "STDAPI" || $r eq "WINOLEAPI"){ $r = "HRESULT"; }
		$r =~ s/\b(?:long)\b/int/g;
		$a =~ s/\/\*.*?\*\///g;
		$a =~ s/\b(?:long)\b/int/g;
		$a =~ s/\b(?:IN|OUT|OPTIONAL|const|CONST|volatile|struct|FAR|NEAR|_huge)\b//g;
		$a =~ s/\bIUnknown\s*\*/LPUNKNOWN /g;
		$a =~ s/\bIStorage\s*\*/LPSTORAGE /g;
		$a =~ s/\bIMalloc\s*\*/LPMALLOC /g;
		$a =~ s/\bIChannelHook\s*\*/LPCHANNELHOOK /g;
		$a =~ s/\bILockBytes\s*\*/LPLOCKBYTES /g;
		$a =~ s/\bIFillLockBytes\s*\*/LPFILLLOCKBYTES /g;
		$a =~ s/\bIBindCtx\s*\*/LPBINDCTX /g;
		$a =~ s/\bIBindStatusCallback\s*\*/LPBINDSTATUSCALLBACK /g;
		if($a =~ /^\s*(?:VOID|void)\s*$/){ $a = ""; }
		$a =~ s/ +/ /g;
		$a =~ s/^ +//g;
		$a =~ s/\n +/\n  /g;
		$a =~ s/\n +$//;
		if($n =~ /^wsprintf[AW]$/){
			print "extern(C) export $r $n($a);\n";
		}else{
			#wvsprintf[AW] are stdcall
			print "extern(Windows) export $r $n($a);\n";
		}
	}elsif($src =~ /^(?:SHSTDAPI_|WINOLEAPI_)\(([^\)]*)\) *([A-Za-z_]\w*) *\((.*?)\) *\; *(?:\/\*.*?\*\/ *)?(?:\/\/.*?)?\n/s){
		#֐
		$src = $';
		$r = $1;
		$n = $2;
		$a = $3;
		$r =~ s/\b(?:long)\b/int/g;
		$a =~ s/\/\*.*?\*\///g;
		$a =~ s/\b(?:long)\b/int/g;
		$a =~ s/\b(?:IN|OUT|OPTIONAL|const|CONST|volatile|struct|FAR|NEAR|_huge)\b//g;
		if($a =~ /^\s*(?:VOID|void)\s*$/){
			$a = "";
		}
		print "extern(Windows) export $r $n($a);\n";
	}elsif($src =~ /^\s*unsigned\s+long\s*PASCAL\s+FAR\s+(\w+)\s*\(([A-Za-z *]*)\)\;\n/){
		#֐(socket.ĥӂ)
		$src = $';
		$n = $1;
		$a = $2;
		$a =~ s/\bIN\b//g;
		$a =~ s/\bconst\b//g;
		$a =~ s/\bFAR\b//g;
		print "extern(Windows) export uint $n($a);\n";
	}elsif($src =~ /^\s*char\s*FAR\s*\*\s*PASCAL\s+FAR\s+(\w+)\s*\(([A-Za-z_ ]*)\)\;\s*\n/){
		#֐(socket.ĥӂ)
		$src = $';
		$n = $1;
		$a = $2;
		$a =~ s/\bIN\b//g;
		$a =~ s/\bstruct\b//g;
		$a =~ s/\bFAR\b//g;
		if($n eq "inet_ntoa"){
			$a = "uint in_";
		}
		print "extern(Windows) export char* $n($a);\n";
	}elsif($src =~ /^\s*struct\s*(hostent|servent|protoent)\s*FAR\s*\*\s*PASCAL\s+FAR\s+(\w+)\s*\(([A-Za-z_ ,*\n]*)\)\;\s*\n/){
		#֐(socket.ĥӂ)
		$src = $';
		$r = $1;
		$n = $2;
		$a = $3;
		$a =~ s/\bIN\b//g;
		$a =~ s/\bconst\b//g;
		$a =~ s/\bFAR\b//g;
		$a =~ s/   +/  /g;
		print "extern(Windows) export $r* $n($a);\n";
	}elsif($src =~ /^(?:_?_inline|FORCEINLINE)[ \n]([A-Z_]\w*)[ \n](?:NTAPI|__cdecl)?[ \n]*([A-Za-z_]\w*) *\((.*?)\)[ \n]*\{.*?(?: *\}\n)+/s){
		#inline֐
		$src = $';
		$t = $1;
		$n = $2;
		$a = $3;
		$a =~ s/\n/ /g;
		if($n eq "GetFiberData"){
			print "PVOID GetFiberData() { asm { mov EAX, FS:[0x10]; mov EAX, [EAX]; } }\n";
		}elsif($n eq "GetCurrentFiber"){
			print "PVOID GetCurrentFiber() { asm { mov EAX, FS:[0x10]; } }\n";
		}elsif($n eq "__InlineInterlockedCompareExchangePointer"){
			print "PVOID __InlineInterlockedCompareExchangePointer(PVOID* Destination, PVOID ExChange, PVOID Comperand){ return(cast(PVOID)cast(LONG_PTR)InterlockedCompareExchange(cast(LONG*)Destination, cast(LONG)cast(LONG_PTR)ExChange, cast(LONG)cast(LONG_PTR)Comperand)); }";
		}else{
			print "// __inline $t $n($a);\n";
		}
	}elsif($src =~ /^\s*(?:IN\b\s*|OUT\b\s*|struct\b\s*)?([A-Za-z_]\w*)\b\s*(?:FAR\s*|far\s*)?(\*?\s*\w+(?:\[\s*(?:\w|\+)*\s*\])?\s*\;)\s*(?:\/\*.*?\*\/\s*|\/\/[^\n]*?)?\n/s){
		#ϐ structunion̗vf
		$src = $';
		$t = $1;
		$n = $2;
		$t =~ s/\b(?:long)\b/int/g;
		print "  $t $n\n";
	}elsif($src =~ /^\s*unsigned\s+short\s+(\w+)\;\n/){
		#ϐ structunion̗vf
		print "  ushort $1;\n";
		$src = $';
	}elsif($src =~ /^ *const +void *\*(\w+)\;\n/){
		#ϐ structunion̗vf
		print "  void* $1;\n";
		$src = $';
	}elsif($src =~ /^ *const +IID *\*(\w+)\;\n/){
		#ϐ structunion̗vf
		print "  IID* $1;\n";
		$src = $';
	}elsif($src =~ /^\s*const +WCHAR *\*(\w+)\; *(?:\/\/.*)?\n/){
		#ϐ structunion̗vf
		print "  WCHAR* $1;\n";
		$src = $';
	}elsif($src =~ /^\s*char\s+FAR\s*\*\s*FAR\s*\*\s*([A-Za-z_]+)\s*\;\s*\/\*.*\*\/\n/){
		#ϐ structunion̗vf
		print "  char** $1;\n";
		$src = $';
	}elsif($src =~ /^\s*struct\s*\{([A-Za-z_0-9 ;,]+)\}\s*([A-Za-z_]+)\s*\;\s*\n/){
		#ϐ structunion̗vf
		$src = $';
		++$dummy;
		#print "  struct _$dummy {$1}\n";
		#print "  _$dummy $2;\n";
		print "  struct {$1}\n";
	}elsif($src =~ /^[ \t]*((?:unsigned)? *[A-Za-z_]+(?: +[A-Za-z_0-9]+)? *\: *[0-9]+ *[;,]) *(?:\/\*.*?\*\/|\/\/.*?)?\n/){
		#rbgtB[hc
		print "// $1\n";
		$src = $';
	}elsif($src =~ /^WINUSERAPI\n\#ifndef _MAC\nLRESULT\nWINAPI\n\#else\nLRESULT\nCALLBACK\n\#endif\n(DefWindowProc[AW])\(.*?\);\n/s){
		#DefWindowProcA/W
		print "extern(Windows) export LRESULT $1(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);\n";
		$src = $';
	}elsif($src =~ /^WINUSERAPI\n\#ifndef _MAC\nLRESULT\nWINAPI\n\#else\nLRESULT\nCALLBACK\n\#endif\n(DefDlgProc[AW])\(.*?\);\n/s){
		#DefDlgProcA/W
		print "extern(Windows) export LRESULT $1(HWND hDlg, UINT Msg, WPARAM wParam, LPARAM lParam);\n";
		$src = $';
	}elsif($src =~ /^WINUSERAPI\n\#ifndef _MAC\nLRESULT\nWINAPI\n\#else\nLRESULT\nCALLBACK\n\#endif\n(DefMDIChildProc[AW])\(.*?\);\n/s){
		#DefMDIChildProcA/W
		print "extern(Windows) export LRESULT $1(HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam);\n";
		$src = $';
	}elsif($src =~ /^WinMain\(.*?\)\;\n/s){
		#WinMain
		print "// WinMain\n";
		$src = $';
	}elsif($src =~ /^ *PROPSHEETPAGEA_V1_FIELDS\n/){
		#
		$src = $';
print <<EOT
  DWORD dwSize;
  DWORD dwFlags;
  HINSTANCE hInstance;
  union {
    LPCSTR pszTemplate;
    PROPSHEETPAGE_RESOURCE pResource;
  }
  union {
    HICON hIcon;
    LPCSTR pszIcon;
  }
  LPCSTR pszTitle;
  DLGPROC pfnDlgProc;
  LPARAM lParam;
  LPFNPSPCALLBACKA pfnCallback;
  UINT* pcRefParent;
EOT
	}elsif($src =~ /^ *PROPSHEETPAGEW_V1_FIELDS\n/){
		#
		$src = $';
print <<EOT
  DWORD dwSize;
  DWORD dwFlags;
  HINSTANCE hInstance;
  union {
    LPCWSTR pszTemplate;
    PROPSHEETPAGE_RESOURCE pResource;
  }
  union {
    HICON hIcon;
    LPCWSTR pszIcon;
  }
  LPCWSTR pszTitle;
  DLGPROC pfnDlgProc;
  LPARAM lParam;
  LPFNPSPCALLBACKW pfnCallback;
  UINT* pcRefParent;
EOT
	}elsif($src =~ /^ *([A-Za-z_][A-Za-z_0-9]*) *\= *([0-9A-Za-fx_]+)\,? *(?:\/\*.*?\*\/|\/\/.*?)?\n/){
		#enum̗vf(lw)
		print "  $1 = $2,\n";
		$src = $';
	}elsif($src =~ /^ *([A-Za-z_][A-Za-z_0-9]*)\,? *(?:\/\*.*?\*\/|\/\/.*?)?\n/){
		#enum̗vf
		if($1 ne "int" && $1 ne "CALLBACK" && $1 ne "WINAPI"){
			print "  $1,\n";
		}else{
			print "// ???\n";
		}
		$src = $';
	}elsif($src =~ /^ *([A-Za-z_][A-Za-z_0-9]*)\, *([A-Za-z_][A-Za-z_0-9]*)\,? *\n/){
		#enum̗vf(sɂӂ)
		print "  $1,\n";
		print "  $2,\n";
		$src = $';
	}else{
		#ȊOAG[ƂƂŎOs\
		&report_error();
		die;
	}
}
